var closy = {

	initialized: false,

	init: function() {
		if (!this.initialized) {
			var tabMenu = document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabContextMenu");
			if (tabMenu) {
				var insertPos = tabMenu.lastChild.previousSibling;

				var ele = document.createElement("menu");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy.label"));
				ele.setAttribute("id", "closy");
				insertPos = tabMenu.insertBefore(ele, insertPos);

				ele = document.createElement("menuseparator");
				ele.setAttribute("id", "closy-sep");
				tabMenu.insertBefore(ele, insertPos);

				ele = document.createElement("menupopup");
				insertPos = insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-blank.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-blank.tooltiptext"));
				ele.setAttribute("id", "closy-blank");
				ele.setAttribute("oncommand", "closy.closeBlankTabs();");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-dupe.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-dupe.tooltiptext"));
				ele.setAttribute("id", "closy-dupe");
				ele.setAttribute("oncommand", "closy.closeDuplicateTabs();");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-title.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-title.tooltiptext"));
				ele.setAttribute("id", "closy-title");
				ele.setAttribute("oncommand", "closy.closeTabsInput(1);");
				insertPos.appendChild(ele);

				ele = document.createElement("menuitem");
				ele.setAttribute("label", document.getElementById("bundle_closy").getString("closy-source.label"));
				ele.setAttribute("tooltiptext", document.getElementById("bundle_closy").getString("closy-source.tooltiptext"));
				ele.setAttribute("id", "closy-source");
				ele.setAttribute("oncommand", "closy.closeTabsInput(2);");
				insertPos.appendChild(ele);

				this.initialized = true;

			} else {
				this.trace("Unable to get tabContextMenu");
			}
		}
	},

	trace: function(aText) {
		try {
			var CONSOLE_SERVICE = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
			CONSOLE_SERVICE.logStringMessage("closy: " + aText);
		} catch(err) {
		}
	},

	// closes tabs based on input from users
	// aType: 1) search in title, 2) search in source
	closeTabsInput: function(aType) {
		var ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var result = { value: "" };
		var dummy = { value: "" };
		var ptitle;
		var pprompt;
		if (aType == 1) {
			ptitle = document.getElementById("bundle_closy").getString("closy-title.title")
			pprompt = document.getElementById("bundle_closy").getString("closy-title.prompt");
		} else {
			ptitle = document.getElementById("bundle_closy").getString("closy-source.title")
			pprompt = document.getElementById("bundle_closy").getString("closy-source.prompt");
		}
		var ans = ps.prompt(window, ptitle, pprompt, result, null, dummy);
		if (ans && result.value) {
			var tabs = gBrowser.mTabContainer.childNodes;
			for (var i = tabs.length-1; i >= 0; i--) {
				var cont = false;
				try {
					if (aType == 1) {
						cont = gBrowser.getBrowserAtIndex(i).contentWindow.document.title;
					} else {
						cont = gBrowser.getBrowserAtIndex(i).contentWindow.document.documentElement.innerHTML;
					}
				} catch(err) {
					this.trace("Unable to get document title/source due to: " + err);
				}
				if (cont && cont.indexOf(result.value) > -1) {
					if (i && gBrowser.selectedTab == tabs[i]) {
						gBrowser.selectedTab = tabs[i-1];
					}
					gBrowser.removeTab(tabs[i]);
				}
			}
		}
	},

	// closes all blank (about:blank) tabs
	closeBlankTabs: function() {
		var tabs = gBrowser.mTabContainer.childNodes;
		for (var i = tabs.length-1; i >= 0; i--) {
			if (gBrowser.getBrowserAtIndex(i).currentURI.spec == "about:blank") {
				if (i && gBrowser.selectedTab == tabs[i]) {
					gBrowser.selectedTab = tabs[i-1];
				}
				gBrowser.removeTab(tabs[i]);
			}
		}
	},

	// closes all duplicate tabs
	closeDuplicateTabs: function() {
		var urlclose = new Array();
		var urlhash = new Object();
		var tabs = gBrowser.mTabContainer.childNodes;
		for (var i = tabs.length-1; i >= 0; i--) {
			var uri = gBrowser.getBrowserAtIndex(i).currentURI.spec;
			if (urlhash[uri]) {
				urlclose[urlclose.length] = i;
			} else {
				urlhash[uri] = true;
			}
		}
		for (i = 0, max = urlclose.length; i < max; i++) {
			gBrowser.removeTab(tabs[urlclose[i]]);
		}
	}

};

var tabMenu = document.getAnonymousElementByAttribute(getBrowser(), "anonid", "tabContextMenu");
if (tabMenu) {
	tabMenu.addEventListener("popupshowing", function(e) {closy.init(e)}, false);
} else {
	closy.trace("Unable to get tabContextMenu");
}
